
import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;


public final class DataHandler extends Object
{
 
	static final int MIN_WIND = 0;
	static final int MAX_WIND = 300;
	static final int MIN_SUN = 0;
	static final int MAX_SUN = 50;
	
	static final List<Integer> wind = new ArrayList<Integer>();
	static final List<Integer> sun = new ArrayList<Integer>();
	static int i=0;
	static int j=0;
	static final Random r = new Random();
	static boolean resun=false, rewind=false;
	static String dataFile = "";
	
	static boolean randomly=!getDataFile();
	
	public static int refresh() {
		i=0; j=0;
		resun=false; rewind=false;
		if (!dataFile.isEmpty()) {
			wind.clear();
			sun.clear();
			readFile();
			return 0;
		}
		return -1;
	}
	
	static boolean getDataFile() {
		System.out.println("DataHandler.getDataFile ...");
		boolean useData = false;
		if (getFileDialog()) {
			useData = readFile();			
		}
		System.out.println("\nWind / Sun  randomly: "+!useData);
		showData();
		return useData;
	}
	
	private static boolean readFile() {
		boolean res = false;
		try {
			Scanner data = new Scanner(new FileReader(dataFile));
			if (data != null) {
				res = data.hasNext();
				while (data.hasNext()) {
					String str = data.next();
					if ("Wind".equals(str)) {
						if (data.hasNextInt()) {
							wind.add(Integer.valueOf(data.nextInt()));
						}
					}
					else if ("Sun".equals(str)) {
						if (data.hasNextInt()) {
							sun.add(Integer.valueOf(data.nextInt()));
						}
					}
				}
				data.close();
			}
		} catch (IOException ex) {}
		return res;
	}
	
	static void showData() {
		for (int n=0; n<wind.size(); n++) {
			System.out.println((n+1) +". Wind: "+wind.get(n));
		}
		System.out.println();
		for (int n=0; n<sun.size(); n++) {
			System.out.println((n+1) +". Sun: "+sun.get(n));
		}
	}
	
	public static boolean hasWind() {
		if (randomly)
			return true;
		else if (wind.size() > i)
			return true;
		else {
			rewind = true;
			return false;
		}
	}
	
	public static boolean hasSun() {
		if (randomly)
			return true;
		else if (sun.size() > j) 
			return true;
		else {
			resun = true;
			return false;
		}
	}
	
	public static int getWind() {
		if (randomly)
			return getWindRandomly();
		else if (rewind) {
			i = 0;
			rewind = false;
			return hasWind()? wind.get(i): 0;
		}	
		else {
			System.out.println(i+". Wind ");
			return hasWind()? wind.get(i++): 0;
		}
	}

	public static int getSun() {
		if (randomly)
			return getSunRandomly();
		else if (resun) {
			j = 0;
			resun = false;
			return hasSun()? sun.get(j): 0;
		}
		else {
			System.out.println(j+". Sun ");
			return hasSun()? sun.get(j++): 0;
		}
	}

	private static int getWindRandomly() {
		return r.nextInt(MAX_WIND);
	}
	
	private static int getSunRandomly() {
		return r.nextInt(MAX_SUN);
	}
	
	public static int reinitWind() {
		i = 0; rewind = false;
		return 0;
	}
	
	public static int reinitSun() {
		j = 0; resun = false;
		return 0;
	}
	
	/* File Dialog  */	
	private static boolean getFileDialog() {
		Object[] options = {"Data File", "Randomly"};
		int answer = JOptionPane
				.showOptionDialog(null,
						"\nChoose <Data File> if you want to load a data file"
						+"\n\t or"
						+"\nchoose <Randomly> if the data should be generated.\n\n",
						"     Please do your choice", JOptionPane.DEFAULT_OPTION,
						JOptionPane.WARNING_MESSAGE, null, options,
						options[0]);
		if (answer == 0) {
			JFileChooser chooser = new JFileChooser(System.getProperty("user.dir"));
			chooser.showOpenDialog(new JFrame());
			File file = chooser.getSelectedFile();
			if (file != null) {
				dataFile = file.getPath();
				System.out.println("Loaded data file:\n"+dataFile);
				return true;
			}
		}

		return false;
	}
	
	public static void main(String[] args) {
	}
	
	public void dispose() {
		System.out.println("Dispose...");
	}
	
	protected void finalize() {
		System.out.println("finalize...");
	}
	
}
